package com.jscape.inet.sftp.protocol.v3.marshaling;

import com.jscape.inet.sftp.protocol.messages.Message;
import com.jscape.inet.sftp.protocol.v3.messages.SshFxpRead;
import com.jscape.inet.ssh.protocol.v2.marshaling.primitive.StringCodec;
import com.jscape.inet.ssh.protocol.v2.marshaling.primitive.Uint32Codec;
import com.jscape.inet.ssh.protocol.v2.marshaling.primitive.Uint64Codec;
import com.jscape.util.io.DataCodec;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

/**
 * @author Alex Usun
 */
public class SshFxpReadCodec
        implements DataCodec<Message> {

    @Override
    public Message read(InputStream in)
            throws IOException {
        int id = Uint32Codec.readValue(in);
        byte[] handle = StringCodec.readValue(in);
        long offset = Uint64Codec.readValue(in);
        int length = Uint32Codec.readValue(in);

        return new SshFxpRead(id, handle, offset, length);
    }

    @Override
    public void write(Message value, OutputStream out)
            throws IOException {
        SshFxpRead message = (SshFxpRead) value;
        Uint32Codec.writeValue(message.id, out);
        StringCodec.writeValue(message.handle, out);
        Uint64Codec.writeValue(message.offset, out);
        Uint32Codec.writeValue(message.length, out);
    }

}
